/* Generated by GOB (v2.0.5)   (do not edit directly) */



/***************************************************************************
                         lum-engine.gob  -  Lumiere Engine 
                             -------------------
    begin                : Tue dec 2 02:08:47 BST 2003
    copyright            : (C) 2003, 2004 by Stéphane Konstantaropoulos
    email                : stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS block
 *
 * $Author: stephanek $
 * $Revision: 1.7 $
 * $Date: 2004/03/27 00:14:31 $
 *
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __LUM_ENGINE_H__
#define __LUM_ENGINE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <gtk/gtk.h>
#include "lum-player-info.h"


typedef enum {
	TARGET_STRING,
	TARGET_URL
} LumEngineTarget;
#define LUM_TYPE_ENGINE_TARGET lum_engine_target_get_type()
GType lum_engine_target_get_type (void);


typedef enum {
	PREV_NONE,
	PREV_VIDEO,
	PREV_VFX,
	PREV_AUDIO
} LumEnginePrev;
#define LUM_TYPE_ENGINE_PREV lum_engine_prev_get_type()
GType lum_engine_prev_get_type (void);


/*
 * Type checking and casting macros
 */
#define LUM_TYPE_ENGINE	(lum_engine_get_type())
#define LUM_ENGINE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_engine_get_type(), LumEngine)
#define LUM_ENGINE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_engine_get_type(), LumEngine const)
#define LUM_ENGINE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), lum_engine_get_type(), LumEngineClass)
#define LUM_IS_ENGINE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), lum_engine_get_type ())

#define LUM_ENGINE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), lum_engine_get_type(), LumEngineClass)

/* Private structure type */
typedef struct _LumEnginePrivate LumEnginePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_LUM_ENGINE__
#define __TYPEDEF_LUM_ENGINE__
typedef struct _LumEngine LumEngine;
#endif
struct _LumEngine {
	GObject __parent__;
	/*< private >*/
	LumEnginePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _LumEngineClass LumEngineClass;
struct _LumEngineClass {
	GObjectClass __parent__;
};


/*
 * Public methods
 */
GType	lum_engine_get_type	(void);
LumEngine * 	lum_engine_new	(void);
GtkWindow * 	lum_engine_get_skin	(LumEngine * self);
void 	lum_engine_load_uri	(LumEngine * self,
					const gchar * uri);
void 	lum_engine_enqueue	(LumEngine * self,
					const gchar * uri);
void 	lum_engine_iconify	(LumEngine * self);
void 	lum_engine_set_volume	(LumEngine * self,
					gdouble volume);
void 	lum_engine_dec_vol	(LumEngine * self);
void 	lum_engine_inc_vol	(LumEngine * self);
void 	lum_engine_mute	(LumEngine * self);
void 	lum_engine_show_info	(LumEngine * self);
void 	lum_engine_do_popup	(LumEngine * self,
					GdkEventButton * event);
void 	lum_engine_switch_timer_mode	(LumEngine * self);
gboolean 	lum_engine_can_seek	(LumEngine * self);
void 	lum_engine_fwd10	(LumEngine * self);
void 	lum_engine_back10	(LumEngine * self);
void 	lum_engine_close	(LumEngine * self);
void 	lum_engine_prev	(LumEngine * self);
void 	lum_engine_next	(LumEngine * self);
void 	lum_engine_play	(LumEngine * self);
void 	lum_engine_pause	(LumEngine * self);
void 	lum_engine_stop	(LumEngine const * self);
gboolean 	lum_engine_get_shuffle	(LumEngine const * self);
void 	lum_engine_set_shuffle	(LumEngine const * self,
					gboolean shuffle);
gboolean 	lum_engine_get_repeat	(LumEngine const * self);
void 	lum_engine_set_repeat	(LumEngine const * self,
					gboolean repeat);
gboolean 	lum_engine_get_playlist_visible	(LumEngine const * self);
void 	lum_engine_set_playlist_visible	(LumEngine const * self,
					gboolean visible);
gboolean 	lum_engine_get_video_window_visible	(LumEngine * self);
void 	lum_engine_set_video_window_visible	(LumEngine const * self,
					gboolean visible);
GList * 	lum_engine_get_list	(LumEngine * self);
void 	lum_engine_play_now	(LumEngine * self,
					LumPlayerInfo * info,
					const gchar * uri);
void 	lum_engine_set_position	(LumEngine * self,
					gdouble position);
void 	lum_engine_show_fileselector	(LumEngine * self);
void 	lum_engine_open_dvd	(LumEngine * self);
void 	lum_engine_open_cdda	(LumEngine * self);
void 	lum_engine_open_activate_cb	(GtkMenuItem * button,
					LumEngine * self);
void 	lum_engine_open_audio_cd_activate_cb	(GtkMenuItem * button,
					LumEngine * self);
void 	lum_engine_open_dvd_activate_cb	(GtkMenuItem * button,
					LumEngine * self);
gboolean 	lum_engine_playlist_delete_cb	(GtkWidget * widget,
					GdkEvent * event,
					gpointer user_data);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
